
Core - Bug # 67445

Status: Resolved Priority: Should have
Author: Morton Jonuschat Category: DBAL
Created: 2015-06-14 Assigned To: Morton Jonuschat
Updated: 2015-07-09 Due date:
TYPO3 Version: 7
PHP Version: 5.6
Complexity:
Is Regression: No
Sprint Focus:
Subject: ALTER TABLE ADD KEY / DROP KEY unsupported
Description

Using DBAL it is currently not possible to add or drop indexes. Only a partial/invalid query is generated from the MySQL Statement in
the SQL Parser.

Input:

ALTER TABLE pages ADD KEY determineSiteRoot (is_siteroot);

Statement generated by SQL Parser:

 (is_siteroot)

Environment: TYPO3 7.3-dev@master
Database: PostgreSQL 9.4

Related issues:
blocks Core - Feature # 67301: Don't suggest database alterations for functio... Resolved 2015-06-05

Associated revisions
Revision 88f2cf21 - 2015-07-09 22:31 - Morton Jonuschat

[TASK] dbal: Add support for ALTER TABLE ADD/DROP KEY

Add support for creating and removing indices to DBAL. The SQL is
generated using the respective ADOdb methods, so adding/removing
PRIMARY keys is not possible.

MySQL prefix lengths will be removed from columns in an index
definition unless the DBMS specifically enables support for this
feature. To ensure that index columns get properly quoted by
ADOdb the field names need to be wrapped in backticks.

Due to the common requirement that index names must be unique within a
database/schema the requested index name will be prepended with a
unique table name identifier.

Resolves: #67445
Resolves: #67531
Releases: master
Change-Id: I274be8df3078867309dde0d5771853c67903719d
Reviewed-on: http://review.typo3.org/40397
Reviewed-by: Stephan Großberndt <stephan@grossberndt.de>
Tested-by: Stephan Großberndt <stephan@grossberndt.de>
Reviewed-by: Markus Klein <markus.klein@typo3.org>
Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

History
#1 - 2015-06-14 23:12 - Frank Nägler
- Category set to DBAL

#2 - 2015-06-15 06:31 - Morton Jonuschat
- Assigned To set to Morton Jonuschat

#3 - 2015-06-15 13:52 - Morton Jonuschat
- Status changed from New to In Progress

#4 - 2015-06-17 22:24 - Gerrit Code Review
- Status changed from In Progress to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397

#5 - 2015-06-18 09:32 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397

#6 - 2015-06-18 22:05 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397

#7 - 2015-06-18 23:20 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397

#8 - 2015-07-09 21:34 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397
#9 - 2015-07-09 21:44 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397

#10 - 2015-07-09 22:02 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397

#11 - 2015-07-09 22:09 - Stephan Großberndt
- Status changed from Under Review to In Progress

#12 - 2015-07-09 22:16 - Gerrit Code Review
- Status changed from In Progress to Under Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397

#13 - 2015-07-09 22:29 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40397

#14 - 2015-07-09 22:34 - Morton Jonuschat
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:88f2cf211d032ac5e1d69dcef5ccfb8d4856d300.
